/******************************************************************************
 *
 * NAME
 *    PSNR.c
 * 
 * VERSION
 *    1.0
 *   
 * DATE
 *    10.9.1998
 *
 * IMPLEMENTATION 
 *    Bertram Ganz (ganz@informatik.uni-freiburg.de)
 *
 * SYNOPSIS    
 *    Usage: PSNR <Original-file> <Collage-file>
 *
 * DESCRIPTION
 *    computes the PSNR value of the compressed image 
 *   
 ******************************************************************************/
#include <stdio.h>
#include <math.h>

FILE   *ori, *col, *ptr1;
char   ch;
unsigned long int  i, j;
int Vergleich(), RMS();

int main(int argc, char **argv)
{
        if(argc != 3)
                {
                  printf("Usage: %s <Original-file> <Collage-file>\n",argv[0]);
                  exit(1);
                }
        ori  = fopen(argv[1],"r");
        col  = fopen(argv[2],"r");
                
        Vergleich();
        RMS();

        fclose(ori);
        fclose(col);
        return 0;
}

int Vergleich()
{
        /* Compute the file sizes and then the PSNR value */
        ptr1 = ori;
        fseek(ptr1, 0L, SEEK_END);
        i = ftell(ptr1);
        printf("filesize 1: %i\n", i);
        
        ptr1 = col; 
        fseek(ptr1, 0L, SEEK_END);
        j = ftell(ptr1);
        printf("filesize 2: %i\n", j);
    
        if (i != j)
          {
            printf("different filesizes !!!\n");
            printf("--> PSNR computation impossible!\n");
            exit(-1); /* Brich Programm ab */
          }             
}

int RMS()
{
        int a, b;
        unsigned long int n;
        double m=0.;
        float rms, PSNR;

        rewind(ori);
        rewind(col);
        while( (a != EOF) ||  (b != EOF) )
        { 
          a = getc(ori);
          b = getc(col);
          m+=(a-b)*(a-b);
        }
        printf("ms = %f\n", m);
        rms = sqrt(m/(float)i);
        printf("rms = %f\n", rms);      
        PSNR = 20.*log10(255./rms); 
        printf("PSNR = %f \[dB\]\n", PSNR);  
        return 0;
}


